﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ContainerShip
{
    internal class DrawingContainerShip : DrawingShip
    {
        public DrawingContainerShip(int speed, float weight, Color bodyColor, Color
            dopColor, bool crane, bool containers) :
        base(speed, weight, bodyColor, 110, 60)
        {
            Ship = new EntityContainerShip(speed, weight, bodyColor, dopColor, crane, containers);
        }        
        public override void DrawTransport(Graphics g)
        {
            if (Ship is not EntityContainerShip containerShip)
            {
                return;
            }

            Pen pen = new(Color.Black);
            Brush dopBrush = new SolidBrush(containerShip.DopColor);
            Brush brOrange = new SolidBrush(Color.Orange);

            base.DrawTransport(g);

            if (containerShip.Containers)
            {
                //Границы контейнеров
                g.DrawRectangle(pen, _startPosX + 15, _startPosY + 15, 30, 15);
                g.DrawRectangle(pen, _startPosX + 55, _startPosY + 15, 30, 15);
                //Заливка контейнеров
                g.FillRectangle(dopBrush, _startPosX + 16, _startPosY + 16, 29, 14);
                g.FillRectangle(dopBrush, _startPosX + 56, _startPosY + 16, 29, 14);
                //Заливка центральных полос на контейнерах
                g.FillRectangle(brOrange, _startPosX + 16, _startPosY + 20, 29, 5);
                g.FillRectangle(brOrange, _startPosX + 56, _startPosY + 20, 29, 5);
            }

            if (containerShip.Crane)
            {
                //Граница стрелы крана
                PointF point1 = new PointF(_startPosX + 50, _startPosY + 10);
                PointF point2 = new PointF(_startPosX + 90, _startPosY + 13);
                PointF point3 = new PointF(_startPosX + 50, _startPosY + 16);
                PointF[] craneArrowBorder = new PointF[3] { point1, point2, point3 };

                //Граница заливки стрелы крана
                PointF point4 = new PointF(_startPosX + 51, _startPosY + 10);
                PointF point5 = new PointF(_startPosX + 84, _startPosY + 13);
                PointF point6 = new PointF(_startPosX + 51, _startPosY + 16);
                PointF[] craneArrowFill = new PointF[3] { point4, point5, point6 };

                g.DrawRectangle(pen, _startPosX + 45, _startPosY, 10, 30);
                g.FillRectangle(brOrange, _startPosX + 46, _startPosY + 1, 9, 29);

                g.DrawPolygon(pen, craneArrowBorder);
                g.FillPolygon(dopBrush, craneArrowFill);

                //Трос и крепление
                g.DrawLine(pen, _startPosX + 90, _startPosY + 14, _startPosX + 90, _startPosY + 40);
                g.DrawLine(pen, _startPosX + 90, _startPosY + 40, _startPosX + 85, _startPosY + 43);
                g.DrawLine(pen, _startPosX + 90, _startPosY + 40, _startPosX + 90, _startPosY + 45);
                g.DrawLine(pen, _startPosX + 90, _startPosY + 40, _startPosX + 95, _startPosY + 43);
            }             
        }
    }
}