﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ContainerShip
{
    internal class RocksMap : AbstractMap
    {
        private readonly Brush rockColor = new SolidBrush(Color.Gray);
        
        private readonly Brush waterColor = new SolidBrush(Color.Aqua);
        protected override void DrawBarrierPart(Graphics g, int i, int j)
        {
            g.FillRectangle(rockColor, i * _size_x, j * _size_y, i * (_size_x +
           1), j * (_size_y + 1));
        }
        protected override void DrawWaterPart(Graphics g, int i, int j)
        {
            g.FillRectangle(waterColor, i * _size_x, j * _size_y, i * (_size_x + 1), j * (_size_y + 1));
        }
        protected override void GenerateMap()
        {
            _map = new int[100, 100];
            _size_x = (float)_width / _map.GetLength(0);
            _size_y = (float)_height / _map.GetLength(1);
            int counter = 0;
            for (int i = 0; i < _map.GetLength(0); ++i)
            {
                for (int j = 0; j < _map.GetLength(1); ++j)
                {
                    _map[i, j] = _water;
                }
            }
            while (counter < 10)
            {
                int x = _random.Next(0, 100);
                int y = _random.Next(0, 100);
                if (_map[x, y] == _water && x < 98 && y < 99)
                {
                    _map[x, y] = _barrier;
                    _map[x + 1, y] = _barrier;
                    _map[x + 2, y] = _barrier;
                    _map[x + 1, y + 1] = _barrier;

                    counter++;
                }
            }
        }
    }
}
