﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ContainerShip
{
    internal class SetShipGeneric<T>
        where T : class
    {
        
        private readonly T[] _places;
        
        public int Count => _places.Length;
       
        public SetShipGeneric(int count)
        {
            _places = new T[count];
        }
        
        public int Insert(T ship)
        {
            return Insert(ship, 0);
        }

        public int Insert(T ship, int position)
        {
            if (position < 0 || position > _places.Length)
            {
                return -1;
            }
            int emptyCellIndex = -1;
            if (_places[position] != null)
            {
                for (int i = position + 1; i < Count; i++)
                {
                    if (_places[i] == null)
                    {
                        emptyCellIndex = i;
                        break;
                    }
                }
                if (emptyCellIndex != -1)
                {
                    for (int i = emptyCellIndex; i > position; i--)
                    {
                        _places[i] = _places[i - 1];
                    }
                }
            }
            else
            {
                _places[position] = ship;
                return position;
            }

            if (emptyCellIndex == -1)
            {
                return -1;
            }
            else
            {
                _places[position] = ship;
                return position;
            }
        }
       
        public T Remove(int position)
        {
            if (position >= Count || position < 0)
            {
                return null;
            }

            T removedObject = _places[position];
            _places[position] = null;
            return removedObject;
        }
        
        public T Get(int position)
        {
            if (position >= Count || position < 0)
            {
                return null;
            }
            return _places[position];
        }
    }
}
